﻿using System;
using Microsoft.SqlServer.Types;

namespace prtree
{
    public class NamedPoint
    {
        public double x;
        public double y;
        public int id;

        public NamedPoint(int id, double x, double y)
        {
            this.id = id;
            this.x = x;
            this.y = y;
        }

        public NamedPoint(int id, SqlGeography g)
        {
            if (g.STNumPoints() != 1)
                throw new Exception("Your SqlGeography wasn't a point!!");
            this.id = id;
            this.x = (double)g.Long;
            this.y = (double)g.Lat;
        }

        public NamedPoint(int id, SqlGeometry g)
        {
            if (g.STNumPoints() != 1)
                throw new Exception("Your SqlGeometry wasn't a point!!");
            this.id = id;
            this.x = (double)g.STX;
            this.y = (double)g.STY;
        }

        public override string ToString()
        {
            return id.ToString();
        }
    }
}
